# Copyright (c) 2014  Dave Love, University of Liverpool
# Licence as for the package itself

%bcond_with cuda

Name:		FIRESTARTER
Version:	1.7.4
Release:	1%{?dist}
Summary:	Processor stress test utility
License:	GPLv3+
URL:		https://tu-dresden.de/zih/firestarter
Source0:	https://tu-dresden.de/zih/forschung/ressourcen/dateien/projekte/firestarter/FIRESTARTER_%(echo %version|tr . -)-tar.gz
BuildRequires:	glibc-static
%if 0%{?el6}%{?el7}
%global dts 1
%endif
# for avx512 support
%{?dts:BuildRequires:  devtoolset-9-gcc}
ExclusiveArch:	x86_64

%description
FIRESTARTER is a handy utility for infrastructure specialists, thermal
engineers, system administrators, and computer scientists that aims at
creating near-peak power consumption on standard compute nodes. It can
be used for tests of cooling and power infrastructures, system
stability test, or as a maximum power consumption baseline for
application energy efficiency studies.

While in different research areas tools such as LINPACK and Prime95
are commonly used, these tools are just highly optimized and compute
intense routines that solve specific computational problems. As stress
test utilities they are unnecessarily hard to use and in many cases
unreliable in terms of power consumption maximization. FIRESTARTER is
a simple yet versatile Open Source tool that reliably exceeds the
power consumption of other stress tests and creates very steady power
consumption patterns.

%prep
%setup -q -n %{name}
rm FIRESTARTER


%build
%{?dts:. /opt/rh/devtoolset-9/enable}
# make %{?_smp_mflags} LINUX_L_FLAGS='-pthread -lrt -lm -static' \
#   LINUX_C_FLAGS="-O0 -fomit-frame-pointer -Wall -std=c99 -DAFFINITY -pthread $OLDMEMCPY"
%make_build LINUX_C_FLAGS='-fomit-frame-pointer -Wall -std=gnu99 -I. -DAFFINITY -g'
%if %{with cuda}
%make_build cuda # LINUX_CUDA_PATH=/usr/local/cuda
%endif


%install
install -D -m755 %name $RPM_BUILD_ROOT%_bindir/%name


%files
%license COPYING LICENSE
%doc README CHANGELOG
%_bindir/%name
%if %{with cuda}
%_bindir/%{name}_cuda
%endif

%changelog
* Tue Jul 21 2020 Dave Love <loveshack@fedoraproject.org> - 1.7.4-1
- New version
- Use DTS 9
- Use %%license

* Wed Mar 28 2018 Dave Love <loveshack@fedoraproject.org> - 1.7.2-1
- New version

* Mon Dec  4 2017 Dave Love <loveshack@fedoraproject.org> - 1.7.1-1
- New version

* Sun Nov 20 2016 Dave Love <loveshack@fedoraproject.org> - 1.5-1
- New version
- BR devtoolset on el6

* Wed Jun 22 2016 Dave Love <loveshack@fedoraproject.org> - 1.4-1
- New version
- Add memcpy patch

* Wed Dec 10 2014 Dave Love <d.love@liverpool.ac.uk> - 1.1-2
- Add ExclusiveArch

* Thu Dec  4 2014 Dave Love <d.love@liverpool.ac.uk> - 1.1-1
- Initial packaging
